#ifndef __norm_list_h
#define __norm_list_h

#include <norm.h>

typedef struct norm_list
{
  void              *data;
  struct norm_list  *prev;
  struct norm_list  *next;
}
NormList;


/* Creates a new list with a first item and
 * corresponding data.
 */
NormList *norm_list_new(void *data);

/* Frees given list, by calling the given NormFunc
 * on each item to let the user specify what to do
 * with the items, and then freeing the items them-
 * selves. Returns number of items freed.
 */
int       norm_list_free(NormList *l, NormFunc free_func);

NormList *norm_list_prepend(NormList *l, void *data);
void      norm_list_append(NormList *l, void *data);
NormList *norm_list_find(NormList *l, void *data, NormCmpFunc cmp_func);
void      norm_list_insert_after(NormList *l, void *data);
NormList *norm_list_remove(NormList *l, NormList *item, NormFunc free_func);
NormList *norm_list_remove_last(NormList *l, NormFunc free_func);
NormList *norm_list_move_to_front(NormList *l, NormList *item);

#endif

