%{

#include <string.h>
#include "tokens.h"

%}


%%
#.*$            	 ; /* ignore comments */
trusted                  return TRUSTED;
read-tracefile           return READTRACE;
write-tracefile          return WRITETRACE;
interface          	 return INTERFACE;
ether|ethernet           return ETHER;
fddi            	 return FDDI;
ip              	 return IP;
tcp             	 return TCP;
udp             	 return UDP;
icmp            	 return ICMP;
layer           	 return LAYER;
link            	 return LINK;
network         	 return NET;
transport       	 return TRANS;
ip-header-length         return NORM_IP_HEADER_LENGTH_CHECK;
ip-total-length          return NORM_IP_TOTAL_LENGTH_CHECK;
ip-header-checksum       return NORM_IP_HEADER_CHECKSUM_CHECK;
ip-header-addr-check     return NORM_IP_HEADER_ADDR_CHECK;
ip-drop-df-fragments	 return NORM_IP_DROP_FRAGS_WITH_DF;
ip-clear-df-and-offset   return NORM_IP_CLEAR_DF;
ip-check-fragment-offset return NORM_IP_CHECK_FRAGMENT_OFF;
ip-header-clear-tos	 return NORM_IP_HEADER_CLEAR_TOS;
ip-check-options         return NORM_IP_CHECK_OPTIONS;
ip-set-ttl               return NORM_IP_SET_TTL;
ip-clear-rf              return NORM_IP_CLEAR_RF;
tcp-need-syn             return NORM_TCP_NEED_SYN;
tcp-verify-checksum      return NORM_TCP_VERIFY_CKSUM;
tcp-check-flags          return NORM_TCP_CHECK_FLAGS;
tcp-check-lengths        return NORM_TCP_CHECK_LENGTHS;
tcp-check-options        return NORM_TCP_CHECK_OPTIONS;
tcp-clear-reserved       return NORM_TCP_CLEAR_RESERVED;
icmp-drop-nonzero-code   return NORM_ICMP_ZERO_CODE_CHECK;
icmp-drop-broadcast      return NORM_ICMP_DROP_BROADCAST;
icmp-drop-multicast      return NORM_ICMP_DROP_MULTICAST;
icmp-verify-checksum     return NORM_ICMP_VERIFY_CKSUM;
icmp-drop-sourcequench   return NORM_ICMP_DROP_SOURCEQUENCH;
udp-verify-checksum      return NORM_UDP_VERIFY_CKSUM;
udp-verify-length        return NORM_UDP_VERIFY_LENGTH;
passive                  return PASSIVE;
debuglevel               return DEBUGLEVEL;
yes|true|on    		 return YES;
no|false|off    	 return NO;
[ \t]+           	 ;
\n                       return '\n';
"/"                      return '/';
[0-9]+"."[0-9]+"."[0-9]+"."[0-9]+  { norm_lval.s = strdup(yytext); return IPADDR; }
[0-9]+                   { norm_lval.i = atoi(yytext); return NUM; }
[[:alnum:]]+    	 { norm_lval.s = strdup(yytext); return STRING; }
%%
int
parse_init(char *configfile)
{
        norm_in = fopen(configfile, "r");        
	if (!norm_in)
	  return 0;

        return 1;
}

void
parse_cleanup(void)
{
        if (norm_in)
          {
	    fclose(norm_in);
            norm_in = NULL;
          }
}

int
norm_wrap()
{
	return 1;
}

